﻿using System.Windows;

using Prism.Ioc;
using Prism.Regions;

namespace TestProject.Views
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 컨테이너 확장 인터페이스
        /// </summary>
        private IContainerExtension containerExtension;

        /// <summary>
        /// 영역 관리자 인터페이스
        /// </summary>
        private IRegionManager regionManager;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow(containerExtension, regionManager)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="containerExtension">컨테이너 확장 인터페이스</param>
        /// <param name="regionManager">영역 관리자 인터페이스</param>
        public MainWindow(IContainerExtension containerExtension, IRegionManager regionManager)
        {
            InitializeComponent();

            this.containerExtension = containerExtension;
            this.regionManager      = regionManager;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 버튼 클릭시 처리하기 - button_Click(sender, e)

        /// <summary>
        /// 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void button_Click(object sender, RoutedEventArgs e)
        {
            MainView view = containerExtension.Resolve<MainView>();

            IRegion region = regionManager.Regions["ContentRegion"];

            region.Add(view);
        }

        #endregion
    }
}